#pragma once
#include "Controllers.h"
#include "KPlayerController.h"

namespace KapitanGame {
	;
	enum class InputState : int {
		Pressed,
		Released,
		Hold
	};
	struct KActionBind {
		KActionBind(std::string name, const InputState expectedInputState, KPlayerController* controllerObject, const KPlayerCommand command, const Controllers controller) :
			Name(std::move(name)), ExpectedInputState(expectedInputState), ControllerObject(controllerObject), Command(command), Controller(controller) {}
		std::string Name;
		InputState ExpectedInputState;
		KPlayerController* ControllerObject;
		KPlayerCommand Command;
		Controllers Controller;
	};
	struct KAxisBind
	{
		KAxisBind(std::string name, KPlayerController* controllerObject, const KPlayerAxisCommand command, const Controllers controller) :
			Name(std::move(name)), ControllerObject(controllerObject), AxisCommand(command), Controller(controller) {}
		std::string Name;
		KPlayerController* ControllerObject;
		KPlayerAxisCommand AxisCommand;
		Controllers Controller;
	};
}

